package com.diagbot.repository;


import com.diagbot.entity.node.base.BaseNode;
import org.springframework.data.neo4j.annotation.Query;
import org.springframework.data.neo4j.repository.Neo4jRepository;

import java.util.List;
import java.util.Map;

public interface BaseNodeRepository extends Neo4jRepository<BaseNode, Long> {

    List<BaseNode> findByNameIs(String name);

    @Query("MATCH (n) RETURN DISTINCT(LABELS(n))")
    List<String> getLabels();

    @Query("MATCH (c:药品解剖学类别)<-[r:药品相关药品解剖学类别]-(y:药品代码通用名)-[r1:药品相关药品通用名称]->(m:药品通用名称) " +
            " RETURN DISTINCT(m.name)+'::'+c.name")
    List<String> getMedClass();

    @Query("match(s:症状) return distinct s.name")
    List<String> getSymptomClass();

    @Query("match(d:疾病)-[r:疾病相关性别]->(h) return d.name,h.name")
    Map<String,String> getDisSexClass();

    @Query("match(d:疾病)-[r:疾病相关年龄]->(h) return d.name,h.name")
    Map<String,String> getDisAgeClass();
}